## openoffice.org-voikko 3.1.1

=== Makefile ===
# Openoffice.org-voikko: Finnish linguistic extension for OpenOffice.org
# Copyright (C) 2005-2009 Harri Pitkänen <hatapitk@iki.fi>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
##########################################################################


# Check that build environment is properly set up
ifndef OO_SDK_HOME
$(error You must run setsdkenv before running make)
endif
PRJ=$(OO_SDK_HOME)
# Load SDK settings
include $(PRJ)/settings/settings.mk
include $(PRJ)/settings/std.mk

# ===== Build settings =====

# Version number of the openoffice.org-voikko extension
VOIKKO_VERSION=3.1.1

# VOIKKO_DEBUG controls the amount of debugging information in the resulting UNO
# package. Possible values are NO (creates an optimized build without any
# debugging information), LOG (creates an optimized build with runtime debug
# logging) and FULL (creates a build with full debugging symbols and logging).
VOIKKO_DEBUG=NO

# If you have installed libvoikko to some non-standard location, uncomment the
# following and adjust the path accordingly. For OS X this must be set if
# a standalone extension is to be built.
# LIBVOIKKO_PATH=/usr/local/voikko
# LIBVOIKKO_PATH=c:/voikko
# LIBVOIKKO_PATH=/Users/paakayttaja/voikko

# If you want to have all of the library and dictionary files included within
# the extension package, uncomment the following and adjust the path to point
# to a directory containing the required files.
# STANDALONE_EXTENSION_PATH=extras
# STANDALONE_EXTENSION_PATH=/Users/paakayttaja/voikko/lib/voikko

# If you want to have a license text to be displayed upon the installation
# of this extension, uncomment the following.
# SHOW_LICENSE=1

# If you want to enable the grammar checker, set this option to 1
ENABLE_GRAMMAR_CHECKER=1

# Setting this option to 1 causes ugly warnings to be added to visible places
# in the extension without removing any functionality (codename "tekstintuho").
# Useful for binary builds that are released for public testing.
# SHOW_UGLY_WARNINGS=1

# Destination directory when installing unpacked extension with
# make install-unpacked
DESTDIR=/usr/lib/openoffice.org-voikko

# === End build settings ===

# Fix for Intel OS X, see issues 69944 and 86121.
ifeq "$(PLATFORM)" "macosx"
	PROCTYPE=$(shell $(PRJ)/config.guess | cut -d "-" -f1)
	ifeq "$(PROCTYPE)" "i686"
		UNOPKG_PLATFORM=MacOSX_x86
	endif
endif

# Platform specific variables
ifeq "$(PLATFORM)" "windows"
	WARNING_FLAGS=-Wall -WX -wd4061 -wd4365 -wd4514 -wd4625 -wd4626 -wd4668 -wd4711 -wd4820
	# The following warnings should be fixed in the future
	WARNING_FLAGS+= -wd4640
	COPYDIR=xcopy /E /I
	PS="\"
else
	WARNING_FLAGS=-Wall -Wno-non-virtual-dtor -Werror
	COPYDIR=cp -r
endif
ifeq "$(PLATFORM)" "linux"
	LINKER_FLAGS=-Wl,--no-undefined
endif


# General variables
ifeq "$(VOIKKO_DEBUG)" "FULL"
	ifeq "$(PLATFORM)" "windows"
		OPT_FLAGS=-Od -Z7
	else
		OPT_FLAGS=-O0 -g
	endif
else
	OPT_FLAGS=-O2
	ifneq "$(PLATFORM)" "windows"
		WARNING_FLAGS+= -fno-strict-aliasing
	endif
endif
# separated generic link flags and linked libs are needed to build with -Wl,--as-needed
# this flag has been enabled by default on openSUSE-11.2
LINK_FLAGS=$(COMP_LINK_FLAGS) $(OPT_FLAGS) $(LINKER_FLAGS)
ifneq "$(PLATFORM)" "macosx"
	LINK_LIBS+=$(SALLIB) $(CPPULIB) $(CPPUHELPERLIB)
endif
VOIKKO_CC_FLAGS=$(OPT_FLAGS) $(WARNING_FLAGS) -Ibuild/hpp -I$(PRJ)/include/stl -I$(PRJ)/include

ifdef STANDALONE_EXTENSION_PATH
	VOIKKO_CC_DEFINES= -DVOIKKO_STANDALONE_EXTENSION
	ifeq "$(PLATFORM)" "windows"
		STANDALONE_EXTENSION_FILES=libvoikko-1.dll 2
	else
		ifeq "$(PLATFORM)" "macosx"
			STANDALONE_EXTENSION_FILES=2
		else
			STANDALONE_EXTENSION_FILES=libvoikko.so.1 2
			LINK_LIBS += -lvoikko
		endif
	endif
else
	VOIKKO_CC_DEFINES=
	STANDALONE_EXTENSION_FILES=
	LINK_LIBS += -lvoikko
endif

ifndef ENABLE_GRAMMAR_CHECKER
	VOIKKO_CC_DEFINES += -DDISABLE_GRAMMAR_CHECKER
endif

# Build extension package name
ifdef SHOW_UGLY_WARNINGS
        VOIKKO_PACKAGENAME:=tekstintuho
        VOIKKO_CC_DEFINES += -DTEKSTINTUHO
else
        VOIKKO_PACKAGENAME:=voikko
endif
ifneq "$(VOIKKO_DEBUG)" "NO"
        VOIKKO_PACKAGENAME:=$(VOIKKO_PACKAGENAME)-dbg
        VOIKKO_CC_DEFINES+= -DVOIKKO_DEBUG_OUTPUT
endif

ifdef LIBVOIKKO_PATH
	LINK_FLAGS+= -L$(LIBVOIKKO_PATH)/lib
	VOIKKO_CC_FLAGS+= -I$(LIBVOIKKO_PATH)/include
endif

VOIKKO_EXTENSION_SHAREDLIB=voikko.$(SHAREDLIB_EXT)
VOIKKO_OBJECTS=registry common PropertyManager spellchecker/SpellAlternatives spellchecker/SpellChecker \
               hyphenator/Hyphenator hyphenator/HyphenatedWord hyphenator/PossibleHyphens \
               grammar/GrammarChecker settings/SettingsEventHandler
VOIKKO_HEADERS=macros common PropertyManager spellchecker/SpellAlternatives spellchecker/SpellChecker \
               hyphenator/Hyphenator hyphenator/HyphenatedWord hyphenator/PossibleHyphens \
               grammar/GrammarChecker settings/SettingsEventHandler
COPY_TEMPLATES=config.xcu config.xcs icon.png SettingsDialog.xdl SettingsDialog_en_US.properties \
               SettingsDialog_fi_FI.properties SettingsDialog.xcu Linguistic.xcu
ifdef SHOW_LICENSE
	COPY_TEMPLATES+=license_fi.txt license_en-US.txt
endif
SRCDIST=COPYING Makefile README ChangeLog $(patsubst %,src/%.hxx,$(VOIKKO_HEADERS)) \
        $(patsubst %,src/%.cxx,$(VOIKKO_OBJECTS)) oxt/description.xml.template \
        $(patsubst %,oxt/%,$(COPY_TEMPLATES)) \
        oxt/META-INF/manifest.xml.template oxt/icon.svg
SED=sed

EXTENSION_FILES=build/oxt/META-INF/manifest.xml build/oxt/description.xml \
	      build/oxt/$(VOIKKO_EXTENSION_SHAREDLIB) \
	      $(patsubst %,build/oxt/%,$(STANDALONE_EXTENSION_FILES)) \
	      $(patsubst %,build/oxt/%,$(COPY_TEMPLATES))

# Targets
.PHONY: extension-files oxt install-unpacked all clean dist-gzip

extension-files : $(EXTENSION_FILES)

oxt: $(EXTENSION_FILES)
	cd build/oxt && $(SDK_ZIP) -r -9 ../$(VOIKKO_PACKAGENAME).oxt \
	   $(patsubst build/oxt/%,%,$^)

all: oxt

install-unpacked: extension-files
	install -m 755 -d "$(DESTDIR)" "$(DESTDIR)/META-INF"
	install -m 644 build/oxt/META-INF/manifest.xml "$(DESTDIR)/META-INF"
	install -m 644 build/oxt/$(VOIKKO_EXTENSION_SHAREDLIB) \
	               build/oxt/description.xml \
	               $(patsubst %,build/oxt/%,$(STANDALONE_EXTENSION_FILES)) \
	               $(patsubst %,build/oxt/%,$(COPY_TEMPLATES)) $(DESTDIR)

# Sed scripts for modifying templates
MANIFEST_SEDSCRIPT:=s/VOIKKO_EXTENSION_SHAREDLIB/$(VOIKKO_EXTENSION_SHAREDLIB)/g;s/UNOPKG_PLATFORM/$(UNOPKG_PLATFORM)/g
DESCRIPTION_SEDSCRIPT:=s/VOIKKO_VERSION/$(VOIKKO_VERSION)/g
ifdef ENABLE_GRAMMAR_CHECKER
	MANIFEST_SEDSCRIPT:=$(MANIFEST_SEDSCRIPT);/GRAMMAR_CHECKER_DISABLED/d
endif
ifdef SHOW_LICENSE
	DESCRIPTION_SEDSCRIPT:=$(DESCRIPTION_SEDSCRIPT);/SHOW_LICENSE/d
endif
ifdef SHOW_UGLY_WARNINGS
	DESCRIPTION_SEDSCRIPT:=$(DESCRIPTION_SEDSCRIPT);s/Voikko/TEKSTINTUHO/g
endif
MANIFEST_SEDSCRIPT:="$(MANIFEST_SEDSCRIPT)"
DESCRIPTION_SEDSCRIPT:="$(DESCRIPTION_SEDSCRIPT)"

# Create extension files
build/oxt/META-INF/manifest.xml: oxt/META-INF/manifest.xml.template
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(SED) -e $(MANIFEST_SEDSCRIPT) < $^ > $@

build/oxt/description.xml: oxt/description.xml.template
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(SED) -e $(DESCRIPTION_SEDSCRIPT) < $^ > $@

$(patsubst %,build/oxt/%,$(COPY_TEMPLATES)): build/oxt/%: oxt/%
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(COPY) "$(subst /,$(PS),$^)" "$(subst /,$(PS),$@)"

$(patsubst %,build/oxt/%,$(STANDALONE_EXTENSION_FILES)): build/oxt/%: $(STANDALONE_EXTENSION_PATH)/%
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(COPYDIR) "$(subst /,$(PS),$^)" "$(subst /,$(PS),$@)"

# Type library C++ headers
build/hpp.flag:
	-$(MKDIR) build$(PS)hpp
	$(CPPUMAKER) -Gc -BUCR -O./build/hpp $(URE_TYPES) $(OFFICE_TYPES)
	echo flagged > $@


# Compile the C++ source files
build/src/%.$(OBJ_EXT): src/%.cxx build/hpp.flag $(patsubst %,src/%.hxx,$(VOIKKO_HEADERS))
	-$(MKDIR) $(subst /,$(PS),$(@D))
	$(CC) $(CC_FLAGS) $(VOIKKO_CC_FLAGS) $(CC_DEFINES) $(VOIKKO_CC_DEFINES) $(CC_OUTPUT_SWITCH)$@ $<


# Link the shared library
build/oxt/$(VOIKKO_EXTENSION_SHAREDLIB): $(patsubst %,build/src/%.$(OBJ_EXT),$(VOIKKO_OBJECTS))
ifeq "$(PLATFORM)" "windows"
	$(LINK) $(COMP_LINK_FLAGS) /OUT:$@ \
	/MAP:build/voikko.map $^ \
	 $(CPPUHELPERLIB) $(CPPULIB) $(SALLIB) $(STLPORTLIB) msvcrt.lib kernel32.lib $(LIBVOIKKO_PATH)\lib\libvoikko-1.lib
	mt -manifest build/oxt/voikko.dll.manifest -outputresource:build/oxt/voikko.dll;2
else
ifeq "$(PLATFORM)" "macosx"
		cat $(PRJ)/settings/component.uno.map > build/voikko.map
		nm -gx $^ | $(ADDSYMBOLS) >> build/voikko.map
		$(LINK) $(COMP_LINK_FLAGS) build/voikko.map $(LINK_LIBS) -o $@ $^ \
		$(CPPUHELPERLIB) $(CPPULIB) $(SALLIB) $(CPPUHELPERDYLIB) $(CPPUDYLIB) $(SALDYLIB) \
		$(LIBVOIKKO_PATH)/lib/libvoikko.a \
		$(LIBVOIKKO_PATH)/lib/libiconv.a \
		$(LIBVOIKKO_PATH)/lib/libintl.a -framework CoreFoundation -framework Carbon
		$(INSTALL_NAME_URELIBS)  $@
else
		$(LINK) $(LINK_FLAGS) $^ -o $@ $(LINK_LIBS)
endif
endif



# Rules for creating the source distribution
dist-gzip: openoffice.org-voikko-$(VOIKKO_VERSION).tar.gz

openoffice.org-voikko-$(VOIKKO_VERSION).tar.gz: $(patsubst %,openoffice.org-voikko-$(VOIKKO_VERSION)/%, \
	                                      $(sort $(SRCDIST)))
	tar c --group 0 --owner 0 openoffice.org-voikko-$(VOIKKO_VERSION) | gzip -9 > $@

$(patsubst %,openoffice.org-voikko-$(VOIKKO_VERSION)/%, $(sort $(SRCDIST))): \
	openoffice.org-voikko-$(VOIKKO_VERSION)/%: %
	install --mode=644 -D $^ $@


# The clean target
clean:
	rm -rf build openoffice.org-voikko-$(VOIKKO_VERSION)
	rm -f openoffice.org-voikko-$(VOIKKO_VERSION).tar.gz

=== debian/changelog ===
openoffice.org-voikko (3.1.1-1) unstable; urgency=low

  * New upstream release
  * Update Standards-Version to 3.8.4
  * Change to 3.0 (quilt) source format

 -- Timo Jyrinki <timo@debian.org>  Wed, 26 May 2010 21:54:25 +0300

openoffice.org-voikko (3.1-2) unstable; urgency=low

  * Don't provide ooo-thesaurus-fi, wrong and not used (Closes: #529490)

 -- Timo Jyrinki <timo@debian.org>  Tue, 09 Jun 2009 22:10:57 +0300

openoffice.org-voikko (3.1-1) unstable; urgency=low

  * New upstream release (Closes: #528283)
  - Grammar checking enabled by default
  * Depend on libvoikko 2.1 (grammar features)
  * Update description to describe grammar checking as well (Closes: #512517)
  * Update Standards-Version (no changes)
  * One more place to change GPL 2 -> 3 in copyright file 
  * Debhelper compat 4 -> 5 and likewise for the related dependency
  * Add back Pre-Depends
  - Ubuntu folks found it is still needed, LP: #364654
  - Only pre-depend on ooo-common this time

 -- Timo Jyrinki <timo@debian.org>  Wed, 13 May 2009 13:25:15 +0300

openoffice.org-voikko (3.0.1-2) unstable; urgency=low

  * Upload to unstable
  * Update copyright (GPL3 like it should be)
  * Disable grammar checking which is not yet mature (wait for 3.1)
  * Remove Pre-Depends which is not anymore needed and is best avoided

 -- Timo Jyrinki <timo@debian.org>  Fri, 20 Feb 2009 10:00:24 +0200

openoffice.org-voikko (3.0.1-1) experimental; urgency=low

  * New upstream release
  * Update maintainer address
  * Update dependencies to openoffice.org 3.0.1 and libvoikko 2.0
  * Sync with upstream debian packaging:
  - Drop HypMinWordLength.patch 
  - Update description

 -- Timo Jyrinki <timo@debian.org>  Tue, 13 Jan 2009 15:42:09 +0200

openoffice.org-voikko (2.2-4) unstable; urgency=low

  * Add voikko-fi to Depends since not dep from libvoikko anymore
  - Could be Recommends, but ooo-voikko does not cope well without
  * Update Standards-Version to 3.8.0, no changes

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Fri, 18 Jul 2008 15:59:39 +0300

openoffice.org-voikko (2.2-3) unstable; urgency=low

  * Add Pre-Depends for etch -> lenny upgrades (Closes: #476573)
  * Modify preinst to remove also multiple previous voikko extensions
  * Fix lintian warning about debian/copyright phrasing

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Mon, 21 Apr 2008 00:26:02 +0300

openoffice.org-voikko (2.2-2) unstable; urgency=low

  * Synchronize with upstream packaging:
    - Update README.Debian instructions
    - Update premrm, postinst, control, and add preinst for OOo 2.4 era
    - Install .oxt to new directory (Closes: #474383)

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Tue, 15 Apr 2008 16:58:04 +0300

openoffice.org-voikko (2.2-1) unstable; urgency=low

  * New upstream release
  * Update Standards-Version to 3.7.3 (no changes)
  * Add Homepage field to control file
  * Add hyphenation patch from upstream, and information about its usage

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Mon, 18 Feb 2008 10:20:08 +0200

openoffice.org-voikko (2.1-1) unstable; urgency=low

  * New upstream release
  * Update dependencies

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Sun, 18 Nov 2007 00:55:16 +0200

openoffice.org-voikko (2.0.1-2) unstable; urgency=low

  * Fix prerm/postinst to handle OOo 2.3 changes

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Tue, 14 Aug 2007 15:26:05 +0300

openoffice.org-voikko (2.0.1-1) unstable; urgency=low

  * New upstream release
  * Sync with upstream Debian packaging, ie:
  * Remove openoffice.org-soikko conflict, not in Debian anymore
  * Fix copyright file (missing line)
  * Install the new Changelog

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Wed, 16 May 2007 00:05:27 +0300

openoffice.org-voikko (2.0-1) unstable; urgency=low

  * New upstream release
  * Update copyright to reflect that the whole package is now under GPL
  * Update dependencies, update maintainer scripts

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Sat, 05 May 2007 04:24:28 +0300

openoffice.org-voikko (1.2-1) unstable; urgency=low

  * New upstream version
  * Remove workaround hack for the bug #387224 (not needed anymore)
  * Add quotes in prerm and postinst in two places
  * Change conflicts generation a bit
  * Text changes because of component rename
  * Fix wrong filename on Linux/SPARC (Closes: #403627)
  * Update home page, watch file

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Sat, 31 Mar 2007 18:18:03 +0300

openoffice.org-voikko (1.1-4) unstable; urgency=low

  * Change Linux_x86 to Linux_* in generate_dependencies.sh
  * Remove stlport from Makefile (not needed anymore)
  * Change dependencies as requested
  * Add OOo components to Recommends

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Sat,  7 Oct 2006 11:41:48 +0300

openoffice.org-voikko (1.1-3) unstable; urgency=low

  * Fix bashism (use of "source") in debian/rules

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Sat, 30 Sep 2006 15:16:23 +0300

openoffice.org-voikko (1.1-2) unstable; urgency=low

  * Add conflict with openoffice.org-soikko
  * Update debian/copyright again

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Tue, 26 Sep 2006 17:59:36 +0300

openoffice.org-voikko (1.1-1) unstable; urgency=low

  * Change package name to openoffice.org-voikko
  * Complete ITP (Closes: #388803)
  * Clean debian/watch
  * Indent homepages in debian/control by two spaces
  * Add COPYING from upstream SVN to clarify copyright issues
  * Update debian/copyright
  * Change CFLAGS to CC_FLAGS in debian/rules
  * Add #DEBHELPER# tokens to prerm and postinst scripts.
  * Update Standards-Version to 3.7.2
  * Clean up debian/rules

 -- Timo Jyrinki <timo.jyrinki@iki.fi>  Mon, 25 Sep 2006 20:37:25 +0300

oo2-voikko (1.1-0hf4) unstable; urgency=low

  * Use /tmp instead of /root as a temporary HOME directory for unopkg
  * Add workaround for the bug #387224 (Debian Bug Tracking System)

 -- Teemu Likonen <tlikonen@iki.fi>  Mon, 18 Sep 2006 23:17:08 +0300

oo2-voikko (1.1-0hf3) unstable; urgency=low

  * Remove "preinst" script.


=== debian/control ===
Source: openoffice.org-voikko
Section: text
Priority: optional
Maintainer: Timo Jyrinki <timo@debian.org>
Build-Depends: debhelper (>= 5.0.0), openoffice.org-dev (>= 1:3.0.1~), libvoikko-dev (>= 2.1), zip
Standards-Version: 3.8.4
Homepage: http://voikko.sourceforge.net/

Package: openoffice.org-voikko
Architecture: any
Pre-Depends: openoffice.org-common
Depends: ${shlibs:Depends}, ${misc:Depends}, voikko-fi
Recommends: openoffice.org (>= 1:3.0.1~) | openoffice.org-writer (>= 1:3.0.1~) | openoffice.org-calc (>= 1:3.0.1~) | openoffice.org-impress (>= 1:3.0.1~) | openoffice.org-draw (>= 1:3.0.1~)
Conflicts: ${misc:Conflicts}
Enhances: openoffice.org
Provides: openoffice.org-spellcheck-fi, openoffice.org-hyphenation-fi
Description: Finnish language tools for OpenOffice.org
 OpenOffice.org is a full-featured office productivity suite that provides
 a near drop-in replacement for Microsoft(R) Office.
 .
 This package contains a Finnish spell-checking, grammar checking and
 hyphenation component for OpenOffice.org. The actual functionality is
 provided by the Voikko library.
 .
 NOTE: Usually spell-checking, grammar checking and hyphenation should be
 automatically activated after installing this package. If this is not the
 case, go to "Writing Aids" settings in OpenOffice.org and activate Voikko
 components manually. See file
 /usr/share/doc/openoffice.org-voikko/README.Debian for more information
 about using this package.

=== debian/rules ===
#!/usr/bin/make -f

CC_FLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CC_FLAGS += -O0
else
	CC_FLAGS += -O2
endif

build: build-stamp
build-stamp: 
	dh_testdir
	sh -c ". /usr/lib/openoffice/basis-link/sdk/setsdkenv_unix.sh && $(MAKE) oxt"
	touch build-stamp

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp
	-rm -rf build
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_install
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	sh debian/generate_dependencies.sh
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3

http://sf.net/voikko/openoffice.org-voikko-(.*)\.tar\.gz
